package com.eactive.eai.agent.property;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.property.PropManager;
import com.eactive.eai.common.util.Logger;

public class ReloadPropertyCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadPropertyCommand() {
		super("ReloadPropertyCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			PropManager manager = PropManager.getInstance();

			String keyName = (String) args;

			if (keyName != null) {
				if ("ALL".equals(keyName)) {
					manager.reload();
					if (logger.isWarn())
						logger.warn(this.name + "] all rule Reload.");
				} else {
					manager.reload(keyName);

					if (logger.isWarn())
						logger.warn(this.name + "] " + keyName + " Reload.");
				}

				if (keyName.startsWith("FileLogger{")) {
					com.eactive.eai.common.util.Logger.setLoggerLevel(keyName);
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//    public static void main(String[] args)throws Exception{
//        Command command = new ReloadPropertyCommand();
//        command.setArgs("ALL");
//        AgentUtil.broadcast(command);
//        
//    }
}
